/*
    QAD - Qt ADvanced

    Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef mapview_tile_downloader_h
#define mapview_tile_downloader_h

#include "mapview_tile_provider_base.h"
#include "mapview_types.h"

#include <QMutex>
#include <QNetworkAccessManager>
#include <QNetworkReply>
#include <QNetworkRequest>
#include <QPixmap>
#include <QQueue>
#include <QThread>
#include <QWaitCondition>

class MapView;

class MapViewTileDownloader: public QThread {
	Q_OBJECT

	friend class MapViewTileCache;

public:
	explicit MapViewTileDownloader(MapView * p);
	~MapViewTileDownloader();

	bool queueTile(MapViewTypes::TileIndex index, bool force = false);
	void queueTiles(QList<MapViewTypes::TileIndex> indeces);
	void clearQueue();

	void setTileProvider(MapViewTileProviderBase * p);
	MapViewTileProviderBase * tileProvider() const { return provider; }

private:
	void run() override;
	void requestTile(MapViewTypes::TileIndex index);

	MapView * parent;
	MapViewTileProviderBase * provider = nullptr;
	QWaitCondition cond;
	QMutex cond_mutex;
	QQueue<MapViewTypes::TileIndex> queue;
	QSet<quint64> in_progress;

public slots:

private slots:
	void tileReady(MapViewTypes::TileIndex index, QPixmap pm);
	void parametersChanged();

signals:
	void tileDone();
};


#endif
